const express = require("express");
const router = express.Router();
let UUIDUtil = require("../utils/UUIDUtil");

const FpService = require("./service/FpService");


fpService = new FpService()

router.post('/getLos', async (req, res) => {
    let uuid = UUIDUtil.uuid;
    let url = req.body.url
    let param = req.body.param
    let html = req.body.html
    let loginCookieStr = req.body.loginCookie
    let publicKey = req.body.publicKey;
    console.log(`${uuid};接收到 ${param} 请求：${url} loginCookieStr: ${loginCookieStr} publicKey: ${JSON.stringify(publicKey)}`);
    if (url == null || url === "") {
        return res.status(500).send("url为空")
    }
//    if (loginCookieStr == null || loginCookieStr === "") {
//        console.error("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE")
//        return res.status(500).send("cookie为空")
//    }
    let start = new Date();
    try {
        // 执行
        let los = await fpService.get_los(url, param, html, loginCookieStr, publicKey);
        // if (!los || los['hd'] === '') {
        //     console.error(`${uuid}; 生成错误！请检查 html 或 cookie, los:${JSON.stringify(los)}`)
        //     return res.status(500).send('生成错误！请检查 html 或 cookie')
        // }
        return res.status(200).send(los);
    } catch (e) {
        console.error(e.stack)
        return res.status(500).send(e.message)
    } finally {
        console.log(`${uuid};getKey ${new Date() - start} ms`)
    }
})

module.exports = router