#!/bin/bash
# 目标目录
cd ../../
# 切换node环境
export NVM_DIR="$([ -z "${XDG_CONFIG_HOME-}" ] && printf %s "${HOME}/.nvm" || printf %s "${XDG_CONFIG_HOME}/nvm")"
[ -s "$NVM_DIR/nvm.sh" ] && \. "$NVM_DIR/nvm.sh" # This loads nvm
#source /usr/share/nvm/init-nvm.sh;
nvm use v20.12.2
npm install --registry=https://registry.npmmirror.com
# 执行打包
tar -cvzf ../qry-python-js.tar.gz --exclude='.git' --exclude='docs' --exclude='dict' --exclude='.idea' *